package com.gic.haoban.manage.service.service.hm.impl;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.gic.api.base.commons.BasePageInfo;
import com.gic.api.base.commons.Page;
import com.gic.commons.util.EntityUtil;
import com.gic.commons.util.PageHelperUtils;
import com.gic.commons.util.UniqueIdUtils;
import com.gic.haoban.manage.api.dto.hm.HmLinkDTO;
import com.gic.haoban.manage.api.dto.hm.HmLinkStoreDTO;
import com.gic.haoban.manage.api.dto.qdto.hm.HmLinkSearchQDTO;
import com.gic.haoban.manage.service.dao.mapper.hm.HmLinkMapper;
import com.gic.haoban.manage.service.entity.hm.TabHmLink;
import com.gic.haoban.manage.service.service.hm.HmLinkService;
import com.gic.haoban.manage.service.service.hm.HmLinkStoreService;
import com.github.pagehelper.PageHelper;

@Service("hmLikService")
public class HmLinkServiceImpl implements HmLinkService {

    @Autowired
    private HmLinkMapper linkMapper;
    @Autowired
    private HmLinkStoreService hmLinkStoreService;

    @Override
    public TabHmLink getByLinkId(String wxEnterpriseId, String enterprieId, Long linkId) {
        TabHmLink link = this.linkMapper.selectById(linkId);
        return link;
    }

    @Override
    public List<HmLinkDTO> listForSms(String wxEnterpriseId, String enterpriseId, String linkName, Integer linkType) {
        List<TabHmLink> list = this.linkMapper.listForSms(wxEnterpriseId, enterpriseId, linkName, linkType);
        return EntityUtil.changeEntityListByJSON(HmLinkDTO.class, list);
    }

    @Override
    @Transactional
    public HmLinkDTO saveLink(HmLinkDTO dto, List<HmLinkStoreDTO> storeList) {
        // 新增
        Long linkId = dto.getLinkId();
        if (null == linkId) {
            linkId = UniqueIdUtils.uniqueLong();
            StringBuilder sb = new StringBuilder("LJ").append("0").append(dto.getLinkType()).append(linkId);
            dto.setLinkId(linkId);
            dto.setLinkCode(sb.toString());
            dto.setStatusFlag(1);
            TabHmLink entity = EntityUtil.changeEntityByJSON(TabHmLink.class, dto);
            this.linkMapper.insert(entity);
        } else {
            TabHmLink entity = EntityUtil.changeEntityByJSON(TabHmLink.class, dto);
            this.linkMapper.update(entity);
        }
        this.hmLinkStoreService.saveStore(linkId, storeList);
        return dto;
    }

    @Override
    public Page<HmLinkDTO> listPage(HmLinkSearchQDTO qdto, BasePageInfo basePageInfo) {
        PageHelper.startPage(basePageInfo);
        String wxEnterpriseId = qdto.getWxEnterpriseId();
        String enterpriseId = qdto.getEnterpriseId();
        Date startDate = qdto.getStartDate();
        Date endDate = qdto.getEndDate();
        Integer linkType = qdto.getLinkType();
        List<TabHmLink> list = this.linkMapper.list(wxEnterpriseId, enterpriseId, startDate, endDate, linkType,
                qdto.getSearchParams());
        Page<HmLinkDTO> page = PageHelperUtils.changePageHelperToCurrentPage(list, HmLinkDTO.class);
        return page;
    }

}
